//-----------------------------------------------------------------------------
//    API_2_ENH_GSDL_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_gsdl;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getSecuredDataLength()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ENH_GSDL_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    //private ToolkitRegistry obReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

    // Number of tests
    byte testCaseNb = (byte) 0x00;
    byte testCaseSubNb =(byte) 0x01;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_GSDL_1 () 
    {
		// Set Formatted SMS PP UPD as an activation event for the applet
        obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
		
		// Set Formatted SMS CB as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);
		
		// Set unformatted SMS PP as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GSDL_1  thisApplet = new API_2_ENH_GSDL_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

		
        

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
			case (byte) 0 :
				// --------------------------------------------
				// Test Case 1 : getSecuredDataLength with various length of TP-OA:2,6 and 12
				if (testCaseSubNb==(byte)3)
					testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x2A)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			
			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
				if (testCaseSubNb==(byte)5)
					testCaseNb = (byte) 2 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
		
			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : getSecuredDataLength with PCNTR =0 
				testCaseNb = (byte) 3 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : getSecuredDataLength with PCNTR =7 
				testCaseNb = (byte) 4 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			
			case (byte) 4 :
				// --------------------------------------------
				// Test Case 5 : getSecuredDataLength with length = 0
				testCaseNb = (byte) 5 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x00)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : User data length = 0x33 
				testCaseNb = (byte) 6 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x33)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : getSecuredDataLength with length = 7F
				testCaseNb = (byte) 7 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 7 :
				// --------------------------------------------
				// Test Case 8 : getSecuredDataLength with length = 80
				testCaseNb = (byte) 8 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 8 :
				// --------------------------------------------
				// Test Case 9 : getSecuredDataLength with the maximumlength
				testCaseNb = (byte) 9 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x79)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;

			case (byte) 9 :
				// --------------------------------------------
				// Test Case 10 : getSecuredDataLength with 2 TPDU TLV
				testCaseNb = (byte) 10 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;

			case (byte) 10 :
				// --------------------------------------------
				// Test Case 11 : getSecuredDataLength with various length of TP-OA:2,6 and 12
				if (testCaseSubNb==(byte)16)
					testCaseNb = (byte) 11 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x2A)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
		
			case (byte) 11 :
				// --------------------------------------------
				// Test Case 12 : getSecuredDataLength with various length of RC/CC/DS 0 and 8
				if (testCaseSubNb==(byte)18)
					testCaseNb = (byte) 12 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
		
			case (byte) 12 :
				// --------------------------------------------
				// Test Case 13 : getSecuredDataLength with PCNTR =0 
				testCaseNb = (byte) 13 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x10)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 13 :
				// --------------------------------------------
				// Test Case 14 : getSecuredDataLength with PCNTR =7 
				testCaseNb = (byte) 14 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			
			case (byte) 14 :
				// --------------------------------------------
				// Test Case 15 : getSecuredDataLength with length = 0
				testCaseNb = (byte) 15 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x00)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 15 :
				// --------------------------------------------
				// Test Case 16 : User data length = 0x33 
				testCaseNb = (byte) 16 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x20)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 16 :
				// --------------------------------------------
				// Test Case 17 : getSecuredDataLength with length = 7F
				testCaseNb = (byte) 17 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6C)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 17 :
				// --------------------------------------------
				// Test Case 18 : getSecuredDataLength with length = 80
				testCaseNb = (byte) 18 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x6D)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
			case (byte) 18 :
				// --------------------------------------------
				// Test Case 19 : getSecuredDataLength with the maximumlength
				testCaseNb = (byte) 19 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x79)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;

			case (byte) 19 :
				// --------------------------------------------
				// Test Case 20 : getSecuredDataLength with 2 TPDU TLV
				testCaseNb = (byte) 20 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
				
			case (byte) 20 :
				// --------------------------------------------
				// Test Case 21 : findTLV device Identities
				testCaseNb = (byte) 21 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getSecuredDataLength() == 0x05)&&
						(envHdlr.getValueByte((short)0)==0x40))
											bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
	
			case (byte) 21 :
				// --------------------------------------------
				// Test Case 22 : try to apply the getSecuredDataLength methode on a SMS-CB
				testCaseNb = (byte) 22 ;

				bRes = false ;
				try {
					if (envHdlr.getSecuredDataLength() == 0x05)
						bRes = false;
				}
				catch (ToolkitException e)    {
					if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT ) 
						bRes = true ;
					else
						bRes = false ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;

			case (byte) 22 :
				// --------------------------------------------
				// Test Case 23 : unformated sms pp envelope
				testCaseNb = (byte) 23 ;

				bRes = false ;
				try {
					short returnvalue = envHdlr.getSecuredDataLength();
				}
				catch (ToolkitException e)    {
					if(e.getReason()== ToolkitException.UNAVAILABLE_ELEMENT ) 
						bRes = true ;
					else
						bRes = false ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseSubNb, bRes) ;
				testCaseSubNb++;
				break;
		}
	}
}
