//-----------------------------------------------------------------------------
//    API_2_ENH_GTPO_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_gtpo;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getTPUDLOffset()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ENH_GTPO_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    //private ToolkitRegistry obReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

	private static EnvelopeHandler envHdlr3;
	private EnvelopeHandler envHdlr4;

    // Number of tests
    byte testCaseNb = (byte) 0x00;
    byte testCaseSubNb =(byte) 0x01;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_GTPO_1 () 
    {
		// Set Formatted SMS PP UPD as an activation event for the applet
        obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
		
		// Set Formatted SMS CB as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_CB);

		// Set unformatted SMS PP as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);

		// Set unformatted SMS PP as an activation event for the applet
        obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_UPD);

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GTPO_1  thisApplet = new API_2_ENH_GTPO_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

		
        

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
		ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
			case (byte) 0 :
				// --------------------------------------------
				// Test Case 1 : use the methode getTPUDLOffset with TP-OA length=2 with EVENT_FORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0D )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : use the methode getTPUDLOffset with TP-OA length=6 with EVENT_FORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 2 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0F )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : use the methode getTPUDLOffset with TP-OA length=12 with EVENT_FORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 3 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x12 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : use the methode getTPUDLOffset with 2 TPDU field with EVENT_FORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 4 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x10 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 4 :
				// --------------------------------------------
				// Test Case 5 : use the methode getTPUDLOffset with TP-OA length=2 with EVENT_FORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 5 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0D )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 5 :
				// --------------------------------------------
				// Test Case 6 : use the methode getTPUDLOffset with TP-OA length=6  with EVENT_FORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 6 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0F )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 6 :
				// --------------------------------------------
				// Test Case 7 : use the methode getTPUDLOffset with TP-OA length=12 with EVENT_FORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 7 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x12 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 7 :
				// --------------------------------------------
				// Test Case 8 : use the methode getTPUDLOffset with 2 TPDU field with EVENT_FORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 8 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x10 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 8 :
				// --------------------------------------------
				// Test Case 9 : use the methode getTPUDLOffset with TP-OA length=2 with EVENT_UNFORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 9 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0D )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 9 :
				// --------------------------------------------
				// Test Case 10 : use the methode getTPUDLOffset with TP-OA length=6 with EVENT_UNFORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 10 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0F )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 10 :
				// --------------------------------------------
				// Test Case 11 : use the methode getTPUDLOffset with TP-OA length=12 with EVENT_UNFORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 11 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x12 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 11 :
				// --------------------------------------------
				// Test Case 12 : use the methode getTPUDLOffset with 2 TPDU field with EVENT_UNFORMATTED_SMS_PP_UPD
				testCaseNb = (byte) 12 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x12 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 12 :
				// --------------------------------------------
				// Test Case 13 : use the methode getTPUDLOffset with TP-OA length=2 with EVENT_UNFORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 13 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0D )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 13 :
				// --------------------------------------------
				// Test Case 14 : use the methode getTPUDLOffset with TP-OA length=6 with EVENT_UNFORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 14 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x0F )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 14 :
				// --------------------------------------------
				// Test Case 15 : use the methode getTPUDLOffset with TP-OA length=12 with EVENT_UNFORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 15 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x12 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 15 :
				// --------------------------------------------
				// Test Case 16 : use the methode getTPUDLOffset with 2 TPDU field with EVENT_UNFORMATTED_SMS_PP_ENV
				testCaseNb = (byte) 16 ;

				bRes = false ;
				try {
					if (envHdlr.getTPUDLOffset()==0x10 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 16 :

				// Test Case 17 : findTLV device Identities
				testCaseNb = (byte) 17 ;

				bRes = false ;
				try {
					if((envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)1)!=TLV_NOT_FOUND)&&
						(envHdlr.getTPUDLOffset() == 0x0D)&&
						(envHdlr.getValueByte((short)0)==0x40))
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 17 :
				// --------------------------------------------
				// Test Case 18 : try to apply the methode getTPUDLOffset On a SMS-CB
				testCaseNb = (byte) 18 ;

				bRes = false ;
				try {
					short returned_value = envHdlr.getTPUDLOffset();
						bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.UNAVAILABLE_ELEMENT)
						bRes = true ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
	
		}
	}
}
