//-----------------------------------------------------------------------------
//    API_2_ERH_GLEN_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_erh_glen;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.EnvelopeResponseHandler.getLength() method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 1.0.0 - 01/08/01
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.EnvelopeResponseHandler
 */
public class API_2_ERH_GLEN_1 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;

    private byte[] LONG_TEXT = new byte[240] ;

	// Number of tests
    byte testCaseNb = (byte) 0x00 ;
        
    /**
     * Constructor of the applet
     */
    public API_2_ERH_GLEN_1() 
    {
		// Specific registration to Unrecognized Envelope
		obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
     }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ERH_GLEN_1 thisApplet = new API_2_ERH_GLEN_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of the EnvelopeResponseHandler class
        EnvelopeResponseHandler EnvRespHdlr = EnvelopeResponseHandler.getTheHandler() ;
        
        
        switch ( testCaseNb ) 
		{
		case (byte) 0 :
				// --------------------------------------------
			// Test Case 1 : length = 0
			testCaseNb = (byte) 1 ;
			bRes = false ;
        
			try {
				bRes = (EnvRespHdlr.getLength() == (short)0) ;
			}
			catch (Exception e)    {    
				bRes = false ;
			}
			reportTestOutcome(testCaseNb, bRes) ;

			return;
				
		case (byte) 1 :
		
				// --------------------------------------------
			// Test Case 2 : length = 9
			testCaseNb = (byte) 2 ;
			bRes = false ;
        
			try {            
				byte[] SMS_TPDU_Value2=new byte[0x07];
						
				Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x07,(byte)0x55);
				EnvRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x07);
				
				bRes = (EnvRespHdlr.getLength() == (short)9) ;
            
			}
			catch (Exception e)    {    
				bRes = false ;
			}
			reportTestOutcome(testCaseNb, bRes) ;

			return;
				
		case (byte) 2 :
			// --------------------------------------------
			// Test Case 3 : length = 253
			testCaseNb = (byte) 3 ;
			bRes = false ;
        
			try {
            
				byte[] SMS_TPDU_Value2=new byte[253];
						
				Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)253,(byte)0x55);
				EnvRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 253);
				
				bRes = (EnvRespHdlr.getLength() == (short)0x0100) ;
            
			}
			catch (Exception e)    {    
				bRes = false ;
			}
	        reportTestOutcome(testCaseNb, bRes) ;
			return;
				
		case (byte) 3 :
			// --------------------------------------------
			// Test Case 4 : length = 7Fh
			testCaseNb = (byte) 4 ;
			bRes = false ;
        
			try {
            
				// Build a 7Fh byte command
				byte[] SMS_TPDU_Value2=new byte[0x7F];
						
				Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x7F,(byte)0x55);
				EnvRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x7F);
				
				bRes = (EnvRespHdlr.getLength() == (short)0x0081) ;
            
			}
			catch (Exception e)    {    
				bRes = false ;
			}
			reportTestOutcome(testCaseNb, bRes) ;

			return;

		case (byte) 4 :
			// --------------------------------------------
			// Test Case 5 : length = 80h
			testCaseNb = (byte) 5 ;
			bRes = false ;
        
			try {
            
				// Build a 80h byte command
				byte[] SMS_TPDU_Value2=new byte[0x80];
						
				Util.arrayFillNonAtomic(SMS_TPDU_Value2,(short)0,(short)0x80,(byte)0x55);
				EnvRespHdlr.appendTLV((byte)0x01,SMS_TPDU_Value2,(short) 0x00, (short) 0x80);
				
				bRes = (EnvRespHdlr.getLength() == (short)0x0083) ;
			}
			catch (Exception e)    {    
				bRes = false ;
			}
			reportTestOutcome(testCaseNb, bRes) ;
			return;
		}
    }
}
